include:
  - remote: "https://gitlab.com/arbetsformedlingen/devops/gitlab-cicd/jobtech-ci/-/raw/v0.3.11/jobtech-ci.yml"
  - remote: "https://gitlab.com/arbetsformedlingen/devops/gitlab-cicd/jobtech-ci/-/raw/v0.3.11/security.yml"

lint:
  stage: lint
  image: node:20
  variables:
    SKIP_ENV_VALIDATION: "true"
  before_script:
    - npm install
  script:
    - npm run lint && npm run ts:check

# Only build image if lint stage successful.
build-docker-image:
  needs: [lint]

unit_tests:
  stage: test
  needs: [lint]
  image: node:20
  before_script:
    - npm install
  script:
    - npm run test:ci
  coverage: '/All files[^|]*\|[^|]*\s+([\d\.]+)/'
  artifacts:
    when: always
    paths:
      - test-report.xml
      - coverage/
    reports:
      junit: test-report.xml
      coverage_report:
        coverage_format: cobertura
        path: coverage/cobertura-coverage.xml

pages:
  stage: deploy
  dependencies:
    - unit_tests
  script:
    - rm -rf public/
    - mkdir public
    - mv coverage/ public/
  artifacts:
    paths:
      - public
  # only:
  #   - main

e2e_tests:
  stage: test
  needs: ["build-docker-image"]
  image: docker:stable
  services:
    - docker:dind
  rules:
    - when: manual
  allow_failure: true
  script:
    - export PROJECT_IMG_REF=$CI_REGISTRY_IMAGE/$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA
    # Login to Nexus
    - docker login -u pipeline-readonly -p "$docker_images_jobtechdev_se_passwd" docker-images.jobtechdev.se
    # Login to GitLab Container Registry
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    # Pull recently built image
    - docker pull $PROJECT_IMG_REF
    # Pull other images
    - docker pull mcr.microsoft.com/playwright:v1.39.0-jammy
    - docker pull docker.io/library/caddy:latest
    - docker pull docker-images.jobtechdev.se/fake-backend/fake-backend:main
    - docker pull docker-images.jobtechdev.se/auth-proxy/auth-proxy:main
    # Set up network
    - docker network create --driver bridge skynet
    # Set up containers
    - docker run -d --name frontend --hostname frontend --network skynet --expose 3000 -e SERVICE_URL="http://backend:8000" -e AUTH_HEADER="Remote-User" $PROJECT_IMG_REF
    - docker run -d --name fakeauth --hostname fakeauth --network skynet --expose 8000 docker-images.jobtechdev.se/auth-proxy/auth-proxy:main
    - docker run -d --name rproxy --hostname rproxy --network skynet --expose 4000 -v $CI_PROJECT_DIR/.devcontainer/Caddyfile:/etc/caddy/Caddyfile:ro docker.io/library/caddy:latest
    - docker run -d --name backend --hostname backend --network skynet --expose 8000 docker-images.jobtechdev.se/fake-backend/fake-backend:main
    # Run tests
    - docker run --ipc=host --network skynet -v $CI_PROJECT_DIR:/code mcr.microsoft.com/playwright:v1.39.0-jammy /bin/bash -c "cd code && npm install -g npm@latest && npm install && PLAYWRIGHT_JUNIT_OUTPUT_NAME=/code/results.xml npm run test:e2e -- --reporter=junit"
  artifacts:
    when: always
    paths:
      - results.xml
    reports:
      junit: results.xml

deploy_onprem_acc:
  extends: .deploy
  when: manual
  variables:
    OVERLAY: "onprem-acc"
